%global pypi_name gnocchi
%global service gnocchi

Summary:        Gnocchi is a API to store metrics and index resources
Name:           %{service}
Version:        4.6.0
Release:        1%{?dist}
License:        ASL 2.0
URL:            http://github.com/gnocchixyz/%{service}
Source0:        https://pypi.io/packages/source/g/%{pypi_name}/%{pypi_name}-%{version}.tar.gz
Source1:        %{pypi_name}-dist.conf
Source2:        %{pypi_name}.logrotate
Source3:        %{name}-api.service
Source4:        %{name}-metricd.service
Source5:        %{name}-statsd.service
Source6:        %{name}-amqpd.service

BuildRequires:  python3-setuptools python3-setuptools_scm python3-sphinx python3-devel systemd python3-tenacity
BuildArch:      noarch

%description
HTTP API to store metrics and index resources.

%package -n     python3-%{service}
Summary:        %{service} python libraries
BuildRequires:  lz4
Requires: python3-numpy python3-daiquiri python3-iso8601 python3-jinja2 python3-keystonemiddleware python3-lz4
Requires: python3-monotonic python3-msgpack python3-oslo-config python3-oslo-db python3-oslo-middleware
Requires: python3-oslo-policy python3-pecan python3-requests python3-swiftclient python3-six
Requires: python3-sqlalchemy python3-stevedore python3-tooz python3-tenacity python3-ujson python3-voluptuous
Requires: python3-werkzeug python3-pytz python3-webob python3-alembic python3-prettytable python3-cotyledon
Requires: python3-jsonpatch python3-cachetools python3-pyparsing python3-paste python3-paste-deploy
Requires: python3-pytimeparse python3-SQLAlchemy-Utils python3-PyYAML python3-psycopg2

%description -n   python3-%{service}
%{service} provides API to store metrics from components and index resources.

This package contains the %{service} python library.

%package        api
Summary:        %{service} api
Requires:       %{name}-common = %{version}-%{release} uwsgi-plugin-python3
Provides:       openstack-%{service}-api = %{version}-%{release}

%description api
%{service} provides API to store metrics from components and index resources.

This package contains the %{service} API service.

%package        common
Summary:        Components common to all %{service} services
BuildRequires: python3-daiquiri python3-jsonpatch python3-oslo-config python3-oslo-concurrency python3-oslo-db
BuildRequires: python3-oslo-log python3-oslo-messaging python3-oslo-policy python3-oslo-reports
BuildRequires: python3-oslo-service python3-lz4 python3-pandas python3-pecan python3-tooz python3-ujson
BuildRequires: python3-werkzeug python3-gnocchiclient python3-pytimeparse
Requires:       python3-%{service} = %{version}-%{release}
Provides:         openstack-%{service}-common = %{version}-%{release}
Provides:         openstack-%{service}-indexer-sqlalchemy = %{version}-%{release}

%description    common
%{service} provides services to measure and collect metrics from components.

%package        metricd
Summary:        %{service} metricd daemon
Requires:       %{name}-common = %{version}-%{release}
Provides:       openstack-%{service}-metricd = %{version}-%{release}

%description metricd
%{service} provides API to store metrics from OpenStack components and index resources.

This package contains the %{service} metricd daemon

%package        amqpd
Summary:        %{service} AMQP 1.0 daemon
Requires:       %{name}-common = %{version}-%{release}
Requires:       python-qpid-proton >= 0.17.0

%description amqpd
%{service} provides API to store metrics from OpenStack components and index resources.
This package contains the %{service} AMQP 1.0 daemon

%package        statsd
Summary:        %{service} statsd daemon
Requires:       %{name}-common = %{version}-%{release}
Provides:       openstack-%{service}-statsd = %{version}-%{release}

%description statsd
%{service} provides API to store metrics from OpenStack components and index resources.

This package contains the %{service} statsd daemon

%package doc
Summary:          Documentation for %{service}
Requires:         python3-%{service} = %{version}-%{release}
Provides:         openstack-%{service}-doc = %{version}-%{release}

%description      doc
%{service} provides services to measure and collect metrics from components.

This package contains documentation files for %{service}.

%prep
%autosetup -n %{service}-%{version} -p1
find . \( -name .gitignore -o -name .placeholder \) -delete
find %{service} -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +
sed -i 's/oslo.policy>=0.3.0.*/oslo.policy>=0.3.0/' setup.cfg

%build
PYTHONPATH=. oslo-config-generator --config-file=%{service}/%{service}-config-generator.conf --output-file=%{service}/%{service}.conf

%{py3_build}

while read name eq value; do
  test "$name" && test "$value" || continue
  sed -i "0,/^# *$name=/{s!^# *$name=.*!#$name=$value!}" %{service}/%{service}.conf
done < %{SOURCE1}

%install
%{py3_install}

mkdir -p %{buildroot}/%{_sysconfdir}/sysconfig/
mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/
mkdir -p %{buildroot}/%{_var}/log/%{name}

install -p -D -m 640 %{SOURCE1} %{buildroot}%{_datadir}/%{service}/%{service}-dist.conf
install -p -D -m 640 %{service}/%{service}.conf %{buildroot}%{_sysconfdir}/%{service}/%{service}.conf

cp -R %{service}/rest/policy.json %{buildroot}/%{_sysconfdir}/%{service}

install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}/tmp
install -d -m 755 %{buildroot}%{_localstatedir}/log/%{service}

install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

install -p -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}-api.service
install -p -D -m 644 %{SOURCE4} %{buildroot}%{_unitdir}/%{name}-metricd.service
install -p -D -m 644 %{SOURCE5} %{buildroot}%{_unitdir}/%{name}-statsd.service
install -p -D -m 644 %{SOURCE6} %{buildroot}%{_unitdir}/%{name}-amqpd.service

ln -sf %{_unitdir}/%{name}-api.service %{buildroot}%{_unitdir}/openstack-%{name}-api.service
ln -sf %{_unitdir}/%{name}-metricd.service %{buildroot}%{_unitdir}/openstack-%{name}-metricd.service
ln -sf %{_unitdir}/%{name}-statsd.service %{buildroot}%{_unitdir}/openstack-%{name}-statsd.service

rm -f %{buildroot}/usr/etc/%{service}/*

%pre common
getent group %{service} >/dev/null || groupadd -r %{service}
if ! getent passwd %{service} >/dev/null; then
  useradd -r -g %{service} -G %{service},nobody -d %{_sharedstatedir}/%{service} -s /sbin/nologin -c "%{service} Daemons" %{service}
fi
exit 0

%post -n %{name}-api
%systemd_post %{name}-api.service

%preun -n %{name}-api
%systemd_preun %{name}-api.service

%post -n %{name}-metricd
%systemd_post %{name}-metricd.service

%preun -n %{name}-metricd
%systemd_preun %{name}-metricd.service

%post -n %{name}-statsd
%systemd_post %{name}-statsd.service

%preun -n %{name}-statsd
%systemd_preun %{name}-statsd.service

%post -n %{name}-amqpd
%systemd_post %{name}-amqpd.service

%preun -n %{name}-amqpd
%systemd_preun %{name}-amqpd.service


%files -n python3-%{service}
%{python3_sitelib}/%{service}
%{python3_sitelib}/%{service}-*.egg-info

%files api
%defattr(-,root,root,-)
%{_bindir}/%{service}-api
%{_unitdir}/%{name}-api.service
%{_unitdir}/openstack-%{name}-api.service

%files common
%dir %{_sysconfdir}/%{service}
%attr(-, root, %{service}) %{_datadir}/%{service}/%{service}-dist.conf
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/%{service}/policy.json
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/%{service}/%{service}.conf
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/logrotate.d/%{name}
%dir %attr(0750, %{service}, root)  %{_localstatedir}/log/%{service}

%defattr(-, %{service}, %{service}, -)
%dir %{_sharedstatedir}/%{service}
%dir %{_sharedstatedir}/%{service}/tmp
%{_bindir}/%{service}-config-generator
%{_bindir}/%{service}-change-sack-size
%{_bindir}/%{service}-upgrade
%{_bindir}/%{service}-injector

%files metricd
%{_unitdir}/%{name}-metricd.service
%{_unitdir}/openstack-%{name}-metricd.service
%{_bindir}/%{service}-metricd

%files statsd
%{_unitdir}/%{name}-statsd.service
%{_unitdir}/openstack-%{name}-statsd.service
%{_bindir}/%{service}-statsd

%files amqpd
%{_bindir}/%{service}-amqpd
%{_unitdir}/%{name}-amqpd.service

%files doc
%doc doc/source/

%changelog
* Sun Oct 08 2023 Miaojun Dong <zoedong@tencent.com> - 4.6.0-1
- Bump version to 4.6.0

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.3.5-6
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.3.5-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu May 18 2023 Shuo Wang <abushwang@tencent.com> - 4.3.5-4
- fix ceilometer-upgrade stuck:
- 1. backport python3 patch
- 2. update gnocchi-api.service
- 3. update Requires

* Wed May 17 2023 Shuo Wang <abushwang@tencent.com> - 4.3.5-3
- backport: Support later versions of tenacity

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.3.5-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 11 2023 Shuo Wang <abushwang@tencent.com> - 4.3.5-1
- initial build
